-
Notifications
You must be signed in to change notification settings - Fork 0
/
Copy pathTwoSum.java
62 lines (56 loc) · 1.79 KB
/
TwoSum.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
package arrays.easy;
import java.util.Arrays;
import java.util.HashMap;
import static java.util.Arrays.binarySearch;
/**
* Problem 1 in Leetcode: https://leetcode.com/problems/two-sum/
*
* Given an array of integers nums and an integer target, return indices of the two numbers such that they add up to target.
*
* You may assume that each input would have exactly one solution, and you may not use the same element twice.
*
* You can return the answer in any order.
*
* Example 1:
* Input: nums = [2,7,11,15], target = 9
* Output: [0,1]
*
* Example 2:
* Input: nums = [3,2,4], target = 6
* Output: [1,2]
*
* Example 3:
* Input: nums = [3,3], target = 6
* Output: [0,1]
*/
public class TwoSum {
public static void main(String[] args) {
int[] nums = {3, 3};
int target = 6;
System.out.println("Brute Force Approach: " + Arrays.toString(bruteForceApproach(nums, target)));
System.out.println("HashMap Approach: " + Arrays.toString(hashmapApproach(nums, target)));
}
private static int[] bruteForceApproach(int[] nums, int target) {
int n = nums.length;
for (int i = 0; i < n - 1; i++) {
for (int j = i + 1; j < n; j++) {
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
return new int[]{-1, -1};
}
private static int[] hashmapApproach(int[] nums, int target) {
int n = nums.length;
HashMap<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < n; i++) {
int difference = target - nums[i];
if (map.containsKey(difference)) {
return new int[]{map.get(difference), i};
}
map.put(nums[i], i);
}
return new int[]{-1, -1};
}
}